/**
 * ******************************************************************************
 *  Copyright Fujitsu.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  You may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * *****************************************************************************
 *
 *  NIFCLOUD SDK for Java
 *
 */
package com.nifty.cloud.sdk.server.model.transform;

import java.util.ArrayList;
import java.util.List;

import com.nifty.cloud.sdk.server.model.Association;
import com.nifty.cloud.sdk.server.model.PrivateIpAddresses;
import com.thoughtworks.xstream.converters.Converter;
import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;

/**
 * ReservationSetType変換クラス。<br />
 * このクラスはレスポンスXMLのreservationSet要素からReservationクラスのリストを生成します。
 *
 */
public class PrivateIpAddressConverter implements Converter {

	private static final String ELEMENT_ASSOCIATION = "association";
	private static final String ELEMENT_PRIMARY = "primary";
	private static final String ELEMENT_PRIVATE_DNS_NAME = "privateDnsName";
	private static final String ELEMENT_PRIVATE_IP_ADDRESS = "privateIpAddress";

	/**
	 * 変換可能なクラスか判定します。
	 *
	 * @param clazz クラス
	 * @return 変換可能な場合true, 変換不可能な場合false
	 *
	 * @see com.thoughtworks.xstream.converters.Converter#canConvert(Class)
	 */
	@SuppressWarnings("rawtypes")
	@Override
	public boolean canConvert(Class clazz) {
		Class[] interfaces = clazz.getInterfaces();
		for(Class i: interfaces) {
			if (i==List.class) {
				return true;
			}
		}
		return false;
	}

	/**
	 * {@literal
	 * InstanceSets要素をList<PrivateIpAddresses>クラスに変換します。}
	 *
	 * @param reader XML読込リーダ
	 * @param context
	 * @return {@literal List<PrivateIpAddresses>オブジェクト}
	 *
	 * @see com.thoughtworks.xstream.converters.Converter#unmarshal(HierarchicalStreamReader, UnmarshallingContext)
	 */
	@Override
	public Object unmarshal(HierarchicalStreamReader reader, UnmarshallingContext context) {
		List<PrivateIpAddresses> privateIpAddresses = new ArrayList<PrivateIpAddresses>();

		Converter associationConverter = new AssociationConverter();

		String name = null;
		while(reader.hasMoreChildren()) {
			reader.moveDown();

			PrivateIpAddresses privateIpAddress = new PrivateIpAddresses();

			while(reader.hasMoreChildren()) {
				reader.moveDown();
				name = reader.getNodeName();
				if (name.equals(ELEMENT_ASSOCIATION)) {
					privateIpAddress.setAssociation((Association) associationConverter.unmarshal(reader, context));
				}
				else if (name.equals(ELEMENT_PRIMARY)) {
					privateIpAddress.setPrimary(new Boolean(reader.getValue()));
				}
				else if (name.equals(ELEMENT_PRIVATE_DNS_NAME)) {
					privateIpAddress.setPublicDnsName(reader.getValue());
				}
				else if (name.equals(ELEMENT_PRIVATE_IP_ADDRESS)) {
					privateIpAddress.setPrivateIpAddress(reader.getValue());
				}

				reader.moveUp();
			}
			reader.moveUp();
			privateIpAddresses.add(privateIpAddress);
		}

		return privateIpAddresses;
	}

	/**
	 * 未実装メソッド
	 */
	@Override
	public void marshal(Object paramObject,
						HierarchicalStreamWriter paramHierarchicalStreamWriter,
						MarshallingContext paramMarshallingContext) {
	}

}
